<?php
/*
 *	Sistema: Gerador de Classes PHP5
 *	Autor: Diego Gomes Araujo
 *	Email: diegogomesaraujo@hotmail.com
 *	Versão: 1.0
 *	Licença: GPL/GNU
 *	Data da criação: 22/03/2008
 *	Hora da criação: 13:45:05
 */

class GeraExceptions {

	private $gerador;
	private $diretorio;

	// função construct da classe
	public function __construct() {
		$this->gerador = new Gerador();
	}
	
	// função responsavel por chamar as funções
	// que geram o conteudo da classe
	public function geraClasseExceptions($diretorio) {
		$this->diretorio = $diretorio;
		$str  = "<?php\n";
		$str .= $this->gerador->getCreditos();
		$str .= "class Exceptions {\n\n";
		$str .= self::geraFunctionsException();
		$str .= "}\n";
		$str .= "?>";
		return self::salvaClasseException($str);
	}
	
	// função que salva as classes
	private function salvaClasseException($conteudo) {
		$caminho = $this->diretorio."/Exceptions.php";
		$file = fopen($caminho,"w+");
		if(fwrite($file, $conteudo)) {
			$msgs = new Msgs($caminho,true);
		} else {
			$msgs = new Msgs($caminho,false);
		}
		fclose($file);
		return $msgs;
	}
	
	// função que gera funções exceptions
	private function geraFunctionsException() {
		$str = "";
		foreach($this->gerador->selecionaTBLs() as $tabela) {
			$str .= "\tprotected function exception".$this->gerador->transformaCaractere($tabela->getTabela())."(\$classe, \$funcao) {\n";
				$str .= "\t\t throw new Exception(\"Ocorreu uma exception na classe '\".\$classe.\"', referente a função '\".\$funcao.\"'.\");\n";
			$str .= "\t}\n\n";
		}
		return $str;
	}
	
	

}